#include <iostream>
#include <SDL.h>
#include <SDL_opengl.h>
#include <IL/il.h>
#include <IL/ilu.h>
#include <time.h>

#include "divers.h"
#include "define.h"
#include "Background.h"
#include "Moteur.h"

//Moteur du jeu
extern Moteur moteur;

Background::Background()
{

}

Background::~Background()
{
   glDeleteTextures(1, &m_IMG_fond);
}

/**************************
*  Change le fond du niveau
*   Le changement se fait a l'initialisation, pour eviter le chargement de texture qui prend de la mmoire a chaque changements.
*   Il suffit de dtruire le background puis l'initialiser pour l'utiliser.
**************************/
bool Background::initialisation(int i)
{
    bool etat = true;

     // On choisis le fond en fonction du fond a afficher.
    switch(i)
    {
        case 1:
            m_IMG_fond = chargerTexture("../media/images/backgrounds/1.gif"); // Fond airs
            break;
        case 2:
            m_IMG_fond = chargerTexture("../media/images/backgrounds/2.gif"); // Fond neige
            break;
        case 3:
            m_IMG_fond = chargerTexture("../media/images/backgrounds/3.gif"); // Fond fret
            break;
        default:
            m_IMG_fond = chargerTexture("../media/images/backgrounds/1.gif"); // Fond airs
            break;
    }

    // Scurite
    if(m_IMG_fond == 0)
        etat = false;

    return etat;
}

/**************************
*          Affiche
*          le fond
**************************/
void Background::afficher()
{
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, m_IMG_fond);
        glBegin(GL_QUADS);
            glTexCoord2d(0, 0);        glVertex2d(             0,             0);
            glTexCoord2d(0, 0.748);    glVertex2d(             0, moteur.getHauteurEcran());
            glTexCoord2d(1, 0.748);    glVertex2d( moteur.getLargeurEcran(), moteur.getHauteurEcran());
            glTexCoord2d(1, 0);        glVertex2d( moteur.getLargeurEcran(),             0);
        glEnd();
    glDisable(GL_TEXTURE_2D);
}
