#include "Graphique.h"
#include "../Moteur.h"

extern Moteur moteur;

GLuint Graphique::m_IMG_goomba    = 0;

void Graphique::animerGoomba(std::vector <Objet> &objets, int id, double &x, double &y, double &w, double &h, int &largeur, int &hauteur)
{
    /* --------------------------
         Animation du sprite
    -------------------------- */
    if(moteur.getEtatSpecial() == false)
    {
        if(SDL_GetTicks() - objets[id].m_tempsAnimation > VITESSE_ANIMATION_GOOMBA)
        {
            objets[id].m_animation++;
            if(objets[id].m_animation > 8)
                objets[id].m_animation = 0;

            objets[id].m_tempsAnimation = SDL_GetTicks();
        }
    }
    else
    {
        if(SDL_GetTicks() - objets[id].m_tempsAnimation > VITESSE_ANIMATION_GOOMBA + 100)
        {
            objets[id].m_animation++;
            if(objets[id].m_animation > 8)
                objets[id].m_animation = 0;

            objets[id].m_tempsAnimation = SDL_GetTicks();
        }
    }

switch(objets[id].m_action)
{
    case MARCHE_GAUCHE:
        switch (objets[id].m_animation)
        {
            case 0:
                x = 0;
                y = 0.930;
                h = 0.070;
                w = 0.260;
                largeur = 17;
                hauteur = 18;
                break;
            case 1:
                x = 0;
                y = 0.860;
                h = 0.070;
                w = 0.260;
                largeur = 17;
                hauteur = 18;
                break;
            case 2:
                x = 0;
                y = 0.785;
                h = 0.075;
                w = 0.250;
                largeur = 16;
                hauteur = 19;
                break;
            case 3:
                x = 0;
                y = 0.715;
                h = 0.070;
                w = 0.250;
                largeur = 16;
                hauteur = 18;
                break;
            case 4:
                x = 0;
                y = 0.645;
                h = 0.070;
                w = 0.250;
                largeur = 16;
                hauteur = 18;
                break;
            case 5:
                x = 0;
                y = 0.570;
                h = 0.075;
                w = 0.260;
                largeur = 17;
                hauteur = 19;
                break;
            case 6:
                x = 0;
                y = 0.495;
                h = 0.075;
                w = 0.250;
                largeur = 16;
                hauteur = 19;
                break;
            case 7:
                x = 0;
                y = 0.420;
                h = 0.075;
                w = 0.250;
                largeur = 16;
                hauteur = 19;
                break;
            case 8:
                x = 0;
                y = 0.348;
                h = 0.073;
                w = 0.260;
                largeur = 17;
                hauteur = 19;
                break;
            default:
                x = 0;
                y = 0.348;
                h = 0.073;
                w = 0.260;
                largeur = 17;
                hauteur = 19;
                break;
        }
        break;
    case MARCHE_DROITE:
        switch (objets[id].m_animation)
        {
            case 0:
                x = 0.260;
                y = 0.930;
                h = 0.070;
                w = 0.260;
                largeur = 17;
                hauteur = 18;
                break;
            case 1:
                x = 0.260;
                y = 0.860;
                h = 0.070;
                w = 0.260;
                largeur = 17;
                hauteur = 18;
                break;
            case 2:
                x = 0.290;
                y = 0.785;
                h = 0.075;
                w = 0.250;
                largeur = 16;
                hauteur = 19;
                break;
            case 3:
                x = 0.290;
                y = 0.715;
                h = 0.070;
                w = 0.250;
                largeur = 16;
                hauteur = 18;
                break;
            case 4:
                x = 0.290;
                y = 0.645;
                h = 0.070;
                w = 0.250;
                largeur = 16;
                hauteur = 18;
                break;
            case 5:
                x = 0.260;
                y = 0.570;
                h = 0.075;
                w = 0.260;
                largeur = 17;
                hauteur = 19;
                break;
            case 6:
                x = 0.290;
                y = 0.495;
                h = 0.075;
                w = 0.250;
                largeur = 16;
                hauteur = 19;
                break;
            case 7:
                x = 0.290;
                y = 0.420;
                h = 0.075;
                w = 0.250;
                largeur = 16;
                hauteur = 19;
                break;
            case 8:
                x = 0.260;
                y = 0.348;
                h = 0.073;
                w = 0.260;
                largeur = 17;
                hauteur = 19;
                break;
            default:
                x = 0.260;
                y = 0.348;
                h = 0.073;
                w = 0.260;
                largeur = 17;
                hauteur = 19;
                break;
        }
        break;
}
}
