#include "Graphique.h"
#include "../Moteur.h"

extern Moteur moteur;

GLuint Graphique::m_IMG_blocs      = 0;
GLuint Graphique::m_IMG_sols       = 0;
GLuint Graphique::m_IMG_tuyaux     = 0;
GLuint Graphique::m_IMG_bonus      = 0;
GLuint Graphique::m_IMG_decors     = 0;
GLuint Graphique::m_IMG_monstres   = 0;

void Graphique::dessinerDecors(std::vector <Objet> &objets, float joueurX, float joueurY)
{
    int nombreObjet = objets.size();

    // Les infos sur la partie de l'image a recuperer
    double x = 0;
    double y = 0;
    double w = 0;
    double h = 0;

    // Les infos sur la taille et la hauteur de l'objet.
    int hauteur = 0;
    int largeur = 0;

    // Les infos sur la position de l'objet sur la carte.
    double x2 = 0;
    double y2 = 0;

    // Afficher les elements  l'cran correctement.
    float m_carteX = joueurX - (moteur.getLargeurEcran() / 2);
    if(m_carteX <= 0)
        m_carteX = 0;
    if(m_carteX > LARGEUR_MAX_CARTE - moteur.getLargeurEcran())
        m_carteX  = LARGEUR_MAX_CARTE - moteur.getLargeurEcran();
    float m_carteY = joueurY - (moteur.getHauteurEcran() / 2);
    if(m_carteY <= 0)
        m_carteY = 0;
    if(m_carteY > HAUTEUR_MAX_CARTE - moteur.getHauteurEcran())
        m_carteY  = HAUTEUR_MAX_CARTE - moteur.getHauteurEcran();

    glEnable(GL_TEXTURE_2D);
    glEnable(GL_ALPHA_TEST);
    glAlphaFunc(GL_GREATER, 0.0f);

    for(int i = 0;i < nombreObjet; i++)
    {
        x2 = objets[i].m_positionX;
        y2 = objets[i].m_positionY;

        // Rcupration des infos en fonction de l'objet a affich.
        if(objets[i].m_type != 505 && objets[i].m_type != 800)
            getInfos(objets[i].m_type, x, y, w, h, largeur, hauteur);
        else if(objets[i].m_type == 800)
            animerGoomba(objets, i, x, y, w, h, largeur, hauteur);
        else
            animerPieces(objets, i, x, y, w, h, largeur, hauteur);

       if (objets[i].m_positionX > m_carteX - largeur && objets[i].m_positionX < m_carteX + moteur.getLargeurEcran() && objets[i].m_positionY > m_carteY - 20 && objets[i].m_positionY < m_carteY + moteur.getHauteurEcran())
       {
            if(OBJETS_INVISIBLES() && objets[i].m_etat == true)
            {

                /* Tout d'abort, on recupere la position de l'image souhait dans la texture
                    Ensuite on la place a l'cran a la position charg, avec la taille de l'objet et sa hauteur. */
                    // Prend sur la bonne image en fonction de la texture de l'objet.

                    if(objets[i].m_type == 505)
                        glBindTexture(GL_TEXTURE_2D, m_IMG_pieces);
                    else if(objets[i].m_type == 800)
                        glBindTexture(GL_TEXTURE_2D, m_IMG_goomba);
                    else
                    {
                        if(objets[i].m_type <= NOMBRE_BLOCS)
                            glBindTexture(GL_TEXTURE_2D, m_IMG_blocs);
                        else if(objets[i].m_type <= NOMBRE_SOLS && objets[i].m_type >= NOMBRE_BLOCS)
                            glBindTexture(GL_TEXTURE_2D, m_IMG_sols);
                        else if(objets[i].m_type <= NOMBRE_TUYAUX && objets[i].m_type >= NOMBRE_SOLS)
                            glBindTexture(GL_TEXTURE_2D, m_IMG_tuyaux);
                        else if(objets[i].m_type <= NOMBRE_BONUS && objets[i].m_type >= NOMBRE_TUYAUX)
                            glBindTexture(GL_TEXTURE_2D, m_IMG_bonus);
                        else if(objets[i].m_type <= NOMBRE_DECORS && objets[i].m_type >= NOMBRE_BONUS)
                            glBindTexture(GL_TEXTURE_2D, m_IMG_decors);
                        else
                            glBindTexture(GL_TEXTURE_2D, m_IMG_monstres);
                    }
                        glBegin(GL_TRIANGLE_STRIP);
                            glTexCoord2f(    x,     y);            glVertex2d(x2 - m_carteX, y2 - m_carteY);
                            glTexCoord2f(    x, y + h);            glVertex2d(x2 - m_carteX, y2 + hauteur - m_carteY);
                            glTexCoord2f(x + w,     y);            glVertex2d(x2 + largeur - m_carteX, y2 - m_carteY);
                            glTexCoord2f(x + w, y + h);            glVertex2d(x2 + largeur - m_carteX, y2 + hauteur - m_carteY);
                        glEnd();
            }
        }
    }
    glDisable(GL_ALPHA_TEST);
    glDisable(GL_TEXTURE_2D);
}

void Graphique::getInfos(int type, double &x, double &y, double &w, double &h, int &largeur, int &hauteur)
{
    switch (type)
    {
    case 0:
        break;
    /* Les blocs */
    case 1:
        x = 0;
        y = 0.750;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 2:
        x = 0.147;
        y = 0.750;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 3:
        x = 0.294;
        y = 0.750;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 4 : // le bloc glace
        x = 0.444;
        y = 0.750;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 5 : // le bloc mauve
        x = 0.591;
        y = 0.750;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 6 : // le bloc rouge
        x = 0.740;
        y = 0.750;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 7 : // le bloc sombre
        x = 0;
        y = 0.454;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 8 : // le bloc ? jaune
        x = 0.147;
        y = 0.454;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 9 : // le bloc ? bleu
        x = 0.294;
        y = 0.454;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 10 : // le bloc marron
        x = 0.444;
        y = 0.454;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 11 : // le bloc bleu
        x = 0.591;
        y = 0.454;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    case 12 : // le bloc gris
        x = 0.740;
        y = 0.454;
        h = 0.250;
        w = 0.128;
        largeur = 16;
        hauteur = 16;
        break;
    /* Les sols */
    case 50 : // le sol orange/jaune h1
        x = 0;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 51 : // le sol orange/jaune h2
        x = 0.031;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 52 : // le sol orange/jaune h3
        x = 0.062;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 53 : // le sol orange/jaune h4
        x = 0.093;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;

        break;
    case 54 : // le sol orange/jaune h5
        x = 0.124;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 55 : // le sol orange/jaune h6
        x = 0.160;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 56 : // le sol orange/jaune m1
        x = 0;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 57 : // le sol orange/jaune m2
        x = 0.031;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 58 : // le sol orange/jaune m3
        x = 0.062;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 59 : // le sol orange/jaune m4
        x = 0.093;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 60 : // le sol orange/jaune m5
        x = 0.124;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 61 : // le sol orange/jaune m6
        x = 0.160;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 62 : // le sol orange/jaune b1
        x = 0;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 63 : // le sol orange/jaune b2
        x = 0.031;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 64 : // le sol orange/jaune b3
        x = 0.062;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 65 : // le sol orange/jaune b4
        x = 0.093;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 66 : // le sol orange/jaune b5
        x = 0.124;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 67 : // le sol orange/jaune b6
        x = 0.155;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 68 : // le sol marron h1
        x = 0.220;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 69 : // le sol marron h2
        x = 0.250;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 70 : // le sol marron h3
        x = 0.280;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 71 : // le sol marron h4
        x = 0.315;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 72 : // le sol marron h5
        x = 0.345;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 73 : // le sol marron m1
        x = 0.220;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 74 : // le sol marron m2
        x = 0.250;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 75 : // le sol marron m3
        x = 0.280;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 76 : // le sol marron m4
        x = 0.310;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 77 : // le sol marron m5
        x = 0.345;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 78 : // le sol marron b1
        x = 0.220;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 79 : // le sol marron b2
        x = 0.250;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 80 : // le sol marron b3
        x = 0.280;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 81 : // le sol marron b4
        x = 0.310;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 82 : // le sol marron b5
        x = 0.345;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 83 : // la glace h1
        x = 0.375;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 84 : // la glace h2
        x = 0.405;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 85 : // la glace h3
        x = 0.435;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 86 : // la glace h4
        x = 0.470;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 87 : // la glace m1
        x = 0.375;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 88 : // la glace m2
        x = 0.405;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 89 : // la glace m3
        x = 0.435;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 90 : // la glace m4
        x = 0.470;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 91 : // la glace b1
        x = 0.375;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 92 : // la glace b2
        x = 0.405;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 93 : // la glace b3
        x = 0.435;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 94 : // la glace b4
        x = 0.470;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 95 : // la roche h1
        x = 0.530;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 96 : // la roche h2
        x = 0.560;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 97 : // la roche h3
        x = 0.595;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 98 : // la roche m1
        x = 0.530;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 99 : // la roche m2
        x = 0.560;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 100 : // la roche m3
        x = 0.595;
        y = 0.500;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 101 : // la roche b1
        x = 0.530;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 102 : // la roche b2
        x = 0.560;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 103 : // la roche b3
        x = 0.595;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 104 : // la plateforme jaune/marron 1
        x = 0.655;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 105 : // la plateforme jaune/marron 1
        x = 0.685;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 106 : // la plateforme jaune/marron 1
        x = 0.720;
        y = 0.750;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 107 : // le fil rouge 1
        x = 0.655;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 108 : // le fil rouge 2
        x = 0.685;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 109 : // le fil rouge 3
        x = 0.720;
        y = 0.250;
        h = 0.250;
        w = 0.030;
        largeur = 16;
        hauteur = 16;
        break;
    case 110 : // le nuage (grand)
        x = 0.784;
        y = 0.500;
        h = 0.500;
        w = 0.158;
        largeur = 80;
        hauteur = 32;
        break;
    /* Les tuyaux */
    case 400 : // le tuyau vert h1
        x = 0.000;
        y = 0.750;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 401 : // le tuyau vert h2
        x = 0.250;
        y = 0.750;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 402 : // le tuyau vert m1
        x = 0.000;
        y = 0.500;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 403 : // le tuyau vert m2
        x = 0.250;
        y = 0.500;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 404 : // le tuyau vert b1
        x = 0.000;
        y = 0.250;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 405 : // le tuyau vert b2
        x = 0.250;
        y = 0.250;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 406 : // le tuyau rouge h1
        x = 0.500;
        y = 0.750;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 407 : // le tuyau rouge h2
        x = 0.750;
        y = 0.750;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 408 : // le tuyau roug m1
        x = 0.500;
        y = 0.500;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 409 : // le tuyau rouge m2
        x = 0.750;
        y = 0.500;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 410 : // le tuyau rouge b1
        x = 0.500;
        y = 0.250;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    case 411 : // le tuyau rouge b2
        x = 0.750;
        y = 0.250;
        h = 0.250;
        w = 0.250;
        largeur = 16;
        hauteur = 16;
        break;
    /* Les bonus */
    case 500: // le bonus caisse
        x = 0.000;
        y = 0.000;
        h = 1;
        w = 0.125;
        largeur = 32;
        hauteur = 32;
        break;
    case 501: // le bonus tonneaux
        x = 0.126;
        y = 0.000;
        h = 1;
        w = 0.110;
        largeur = 28;
        hauteur = 32;
        break;
    case 502: // le bonus tonneaux saut
        x = 0.233;
        y = 0.000;
        h = 1;
        w = 0.110;
        largeur = 28;
        hauteur = 32;
        break;
    case 503: // le bonus cible
        x = 0.344;
        y = 0.500;
        h = 0.500;
        w = 0.0625;
        largeur = 16;
        hauteur = 16;
        break;
    case 504: // le bonus invisible
        x = 0.344;
        y = 0.000;
        h = 0.500;
        w = 0.0625;
        largeur = 16;
        hauteur = 16;
        break;
    case 505: // les pieces
        break;
    case 506 : // le depart
        x = 0.4065;
        y = 0.000;
        h = 0.500;
        w = 0.0625;
        largeur = 16;
        hauteur = 16;
        break;
    case 507 : // la case H
        x = 0.469;
        y = 0.500;
        h = 0.500;
        w = 0.0625;
        largeur = 16;
        hauteur = 16;
        break;
    case 508 : // la case B
        x = 0.469;
        y = 0.000;
        h = 0.500;
        w = 0.0625;
        largeur = 16;
        hauteur = 16;
        break;
    case 509 : // la case G
        x = 0.5315;
        y = 0.500;
        h = 0.500;
        w = 0.0625;
        largeur = 16;
        hauteur = 16;
        break;
    case 510 : // la case D
        x = 0.5315;
        y = 0.000;
        h = 0.500;
        w = 0.0625;
        largeur = 16;
        hauteur = 16;
        break;
        /**************************
        *         Les decors
        *
        **************************/
    case 600: // la fleur rose
        x = 0.000;
        y = 0.000;
        h = 0.484;
        w = 0.105;
        largeur = 27;
        hauteur = 31;
        break;
    case 601: // la fleur bleue
        x = 0.106;
        y = 0.000;
        h = 0.437;
        w = 0.112;
        largeur = 29;
        hauteur = 28;
        break;
    case 602: // le gros buisson
        x = 0.219;
        y = 0.000;
        h = 0.703;
        w = 0.339;
        largeur = 87;
        hauteur = 45;
        break;
    case 603: // le petit buisson
        x = 0.559;
        y = 0.000;
        h = 0.406;
        w = 0.128;
        largeur = 33;
        hauteur = 26;
        break;
    case 604: // le portail
        x = 0.688;
        y = 0.000;
        h = 0.344;
        w = 0.125;
        largeur = 32;
        hauteur = 22;
        break;
    /* Les monstres */
    case 800 : // le goomba
        x = 0.0;
        y = 0.0;
        h = 0.563;
        w = 0.500;
        largeur = 16;
        hauteur = 18;
        break;
    case 801 : // le koopa
        x = 0.500;
        y = 0.000;
        h = 0.938;
        w = 0.500;
        largeur = 16;
        hauteur = 30;
        break;
    default:
        break;
    }
}
