#include "Graphique.h"
#include "../Moteur.h"

extern Moteur moteur;

void Graphique::initParticules(std::vector<Particule> &particules, float joueurX, float joueurY)
{
    int nombreObjets = particules.size();
    for(int i = 0;i < nombreObjets; i++)
    {
         // Savoir si l'on affiche le joueur au centre ou a sa vraie position.
        float afficherJoueurX = (moteur.getLargeurEcran() / 2);
        if(joueurX < (moteur.getLargeurEcran() / 2))
            afficherJoueurX = joueurX;

        // Si le joueur arrive au bout du niveau
        if(joueurX > LARGEUR_MAX_CARTE - (moteur.getLargeurEcran() / 2))
            afficherJoueurX = joueurX - LARGEUR_MAX_CARTE + moteur.getLargeurEcran();

        // Si le joueur est en bas du niveau
        float afficherJoueurY = (moteur.getHauteurEcran() / 2);
        if(joueurY < (moteur.getHauteurEcran() / 2))
            afficherJoueurY = joueurY;

        particules[i].m_etat = true;
        particules[i].m_transparence = 255;
        particules[i].m_positionX = afficherJoueurX;
        particules[i].m_positionY = afficherJoueurY;
        particules[i].m_vx = particules[i].myRand(-0.8, 0.1);
        particules[i].m_vy = particules[i].myRand(-1.5, -1);
        particules[i].m_taille = particules[i].myRand(-20, 20);
        particules[i].r = particules[i].myRand(0, 255);
        particules[i].g = particules[i].myRand(0, 255);
        particules[i].b = particules[i].myRand(0, 255);
    }
}

void Graphique::dessinerParticules(std::vector<Particule> &particules, int tempsEcoule)
{
    int nombreObjets = particules.size();
    for(int i = 0;i < nombreObjets; i++)
    {
        if(particules[i].m_etat == true)
        {
            // On effectue les changements.
            particules[i].m_positionY -= particules[i].m_vy * tempsEcoule;
            particules[i].m_positionX += particules[i].m_vx * tempsEcoule;


                glBegin(GL_TRIANGLE_STRIP);
                    //glColor4ub(particules[i].r,particules[i].g,particules[i].b, particules[i].m_transparence);
                    glVertex2d(particules[i].m_positionX - particules[i].m_taille, particules[i].m_positionY-particules[i].m_taille);
                    glVertex2d(particules[i].m_positionX - particules[i].m_taille, particules[i].m_positionY + particules[i].m_taille);
                    glVertex2d(particules[i].m_positionX + particules[i].m_taille, particules[i].m_positionY-particules[i].m_taille);
                    glVertex2d(particules[i].m_positionX + particules[i].m_taille, particules[i].m_positionY+particules[i].m_taille);
                glEnd();

                particules[i].m_transparence -= 5;

                if(particules[i].m_transparence <= 10)
                    particules[i].m_transparence = 0;
        }
    }
    glColor3d(255,255,255);
}
