/**         Jeu.h        **
*
*  Gere l'affichage des elements du jeu.
*
**/

#ifndef JEU
#define JEU

#include <iostream>
#include <SDL.h>
#include <vector>
#include <string>
#include <cstring>
#include <sstream>
#include <fstream>

#include "Audio/Audio.h"
#include "Graphique/Graphique.h"
#include "Physique/Physique.h"
#include "Ia/IA.h"

#include "Background.h"
#include "Objet.h"
#include "Particule.h"
#include "Joueur.h"
#include "Texte.h"
#include "divers.h"

class Jeu
{
public:
    Jeu();
    ~Jeu();
    bool initialisation();

    // Affichage
    void afficher();

    // Gestion
    void gestion();

    // Niveau
    void charger(int niveau, int zone);
    void changerNiveau(int niveauDemander);

    // Clavier
    void clavier(unsigned char k);
    void clavierRelacher(unsigned char k);

private:
    // Joueur
    Joueur *joueur;

    // Tout ce qui se trouve dans le monde et la position pour l'afficher
    std::vector <Objet> objets;
    std::vector <Particule> particules;

    int m_niveau;
    int m_zone;

    // Physique
    int m_tempsPrecedent;
    int m_tempsEcoule;

    // Commencer la partie
    bool m_commencer;


};

#endif
