/**         Joueur.h        **
*
*  Gere le joueur
*
**/

#ifndef JOUEUR
#define JOUEUR

#include <iostream>
#include <vector>
#include <SDL.h>
#include <SDL_opengl.h>

#include "divers.h"
#include "define.h"
#include "Objet.h"
#include "Particule.h"
#include "Texte.h"

class Joueur
{
public:
    Joueur();
    bool initialiser(float x, float y);

    // Afficher
    void afficher();

    // Gestion
    void gestion(std::vector<Objet> &objets, std::vector<Particule> &particules, int tempsPrecedent);
    void gestionObjetJoueur(std::vector<Objet> &objets, int objetEnCollisionX, int objetEnCollisionY);

    // Clavier
    void clavier(unsigned char k);
    void clavierRelacher(unsigned char k);

    // Intraction avec objets
    bool prendreObjet(std::vector<Objet> objets);
    void jeterObjet(std::vector<Objet> &objets);
    void tenirObjet(std::vector<Objet> &objets);

    // Rcupration
    float getPositionX();
    float getPositionY();
private:
    // Le joueur possde une position prcise dans le niveau ainsi que des vitesses.
    float m_joueurX;
    float m_joueurY;
    float m_vx;
    float m_vy;
    // Si le joueur tombe dans le vide on le fait r-appraitre au derniere endroit connus.
    float m_lastJoueurX;
    float m_lastJoueurY;

    // Les vies et degats
    int m_nombreVies;
    int m_degats;
    int m_etat;

    // Pour animer le joueur.
    int m_action;
    int m_direction;

    // Gestion des sauts
    int m_nombreSauts;

    // Gestion des touches
    int haut;
    int droite;
    int gauche;




    // Porter les objet
    bool m_demanderPorter;
    int  m_objetPorter;
};

#endif


