#include "Moteur.h"

Moteur::Moteur()
{
    jeu            =  new Jeu();
    m_fullScreen   =  false; // Pleine ecran par default
    m_largeurEcran =  1024; // Largeur par dfault.
    m_hauteurEcran =   768; // Hauteur par dfault.
    quitter        = false; // A la base on ne quitte pas.

    // Spcial
    bulletTime = false;
}

Moteur::~Moteur()
{
    delete jeu;
}


bool Moteur::initialisation()
{
    return jeu->initialisation();
}

/***************************
*
*        Affichage
*
*************************** */
void Moteur::afficherScene()
{
    // Nettoyage de l'ecran
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glEnable(GL_BLEND);

    afficherJeu();

    glDisable(GL_BLEND);

    // Mise  jour de l'cran
    glFlush();
    SDL_GL_SwapBuffers();
}

void Moteur::afficherJeu()
{
    jeu->gestion();
    jeu->afficher();
}

/***************************
*
*         Clavier
*
*************************** */
void Moteur::clavier(unsigned char k)
{
    jeu->clavier(k);
}

void Moteur::clavierRelacher(unsigned char k)
{
    jeu->clavierRelacher(k);
}

/***************************
*
*     Taille de l'ecran
*
*************************** */
void Moteur::changerLargeur(int largeur)
{
    m_largeurEcran = largeur;
}

void Moteur::changerHauteur(int hauteur)
{
    m_hauteurEcran = hauteur;
}

int Moteur::getLargeurEcran()
{
    return m_largeurEcran;
}

int Moteur::getHauteurEcran()
{
    return m_hauteurEcran;
}

/***************************
*
*       Pleine ecran
*
*************************** */
void Moteur::changerFullScreen(int fullscreen)
{
    m_fullScreen = fullscreen;
}

bool Moteur::getFullScreen()
{
    return m_fullScreen;
}

/***************************
*
*        Autres
*
*************************** */
void Moteur::demanderChangementNiveau(int niveau)
{
    jeu->changerNiveau(niveau);
}

/***************************
*
*           Fin
*
*************************** */
void Moteur::demanderFin()
{
    quitter = true;
}

bool Moteur::fin()
{
    return quitter;
}

/***************************
*
*        Spcial
*
*************************** */
bool Moteur::getEtatSpecial()
{
    return bulletTime;
}

void Moteur::changerEtatBulletTime()
{
    bulletTime = !bulletTime;
}
