/**         Moteur.h        **
*
*  Moteur du jeu, il assure l'initialisation, et la communication entre les differentes classes.
*
**/

#ifndef MOTEUR
#define MOTEUR

#include <iostream>
#include <SDL.h>

#include "define.h"
#include "divers.h"
#include "Jeu.h"

class Moteur
{
public:
    Moteur();
    ~Moteur();
    bool initialisation();

    // Affichage
    void afficherScene();

    // Gestion
    void gererScene();

    // Clavier
    void clavier(unsigned char k);
    void clavierRelacher(unsigned char k);

    // Rsolution et parametres
    int  getLargeurEcran();
    int  getHauteurEcran();
    void changerLargeur(int largeur);
    void changerHauteur(int hauteur);

    // Pour changer de mode
    void changerFullScreen(int fullscreen);
    bool getFullScreen();

    // Changer de Niveau
    void demanderChangementNiveau(int niveau);

    // Quitter
    void demanderFin();
    bool fin();

    // Spcial (Bullet time, ... )
    bool getEtatSpecial();
    void changerEtatBulletTime();

private:
    Jeu *jeu;

    // Affichage
    void afficherJeu();

    // Rsolution et parametres
    int m_largeurEcran;
    int m_hauteurEcran;
    bool m_fullScreen;

    // Activer Bullet time :)
    bool bulletTime;

    // Quitter
    bool quitter;
};

#endif
