/**         Physique.h        **
*
*  Gere les collisions, ...
*
**/

#ifndef PHYSIQUE
#define PHYSIQUE

#include <iostream>
#include <SDL.h>
#include <vector>
#include <math.h>


#include "../define.h"
#include "../Objet.h"

class Physique
{
public:
    Physique();


    // Partie Decors
    static void gestionDecors(std::vector<Objet> &objets, float positionJoueurX, float positionJoueurY, int tempsEcoule);
    static bool deplacementSurY(int id, std::vector<Objet> &objets, float positionJoueurX, float positionJoueurY, int tempsEcoule, bool bougerX);
    static bool deplacementSurX(int id, std::vector<Objet> &objets, float positionJoueurX, float positionJoueurY, int tempsEcoule);

    // Partie Joueur
    static void gestionJoueur(std::vector<Objet> &objets, float &m_joueurX, float &m_joueurY, float &m_vx, float &m_vy, int &objetEnCollisionX, int &objetEnCollisionY, float &lastJoueurX, float &lastJoueurY, int etat, int tempsEcoule);
    static bool joueurBougerX(std::vector<Objet> &objets, float &m_joueurX, float &m_joueurY, float &m_vx, float &m_vy, int &objetEnCollisionX, int &objetEnCollisionY, int tempsEcoule);
    static bool joueurBougerY(std::vector<Objet> &objets, float &m_joueurX, float &m_joueurY, float &m_vx, float &m_vy, int &objetEnCollisionX, int &objetEnCollisionY, float &lastJoueurX, float &lastJoueurY, int tempsEcoule);
    static void antibugJoueur(std::vector<Objet> &objets, float &m_joueurX, float &m_joueurY, float m_vy, float m_vx, int etat);
    static void mouvementsJoueur(int &m_action, int &m_direction, bool demanderPorter, float &vx, float &vy, int &nombreSauts, int droite, int gauche, int tempsEcoule);

};

#endif

