#include "Texte.h"
#include "Moteur.h"

//Moteur du jeu
extern Moteur moteur;

GLuint Texte::m_texte = 0;
unsigned int Texte::m_gauche_txtW = 0;
unsigned int Texte::m_gauche_txtH = 0;
unsigned int Texte::m_gauche_fulltxtW = 0;
unsigned int Texte::m_gauche_fulltxtH = 0;


Texte::Texte()
{
    glGenTextures(1, &m_texte);
}

Texte::~Texte()
{
    glDeleteTextures(1, &m_texte);
}

void Texte::creerTexte(const char texteDemander[], int taille)
{
    createTextureFromText(m_texte, texteDemander, m_gauche_txtW, m_gauche_txtH, m_gauche_fulltxtW, m_gauche_fulltxtH, taille);
}

void Texte::afficherTexte()
{
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

        glBindTexture(GL_TEXTURE_2D, m_texte);
        double ru = (double)m_gauche_txtW/m_gauche_fulltxtW;
        double rv = (double)m_gauche_txtH/m_gauche_fulltxtH;
            glBegin(GL_QUADS);
                glTexCoord2d(0, 1-rv);     glVertex2i(moteur.getLargeurEcran() - m_gauche_txtW - 5 ,0);
                glTexCoord2d(0, 1);        glVertex2i(moteur.getLargeurEcran() - m_gauche_txtW - 5 ,m_gauche_txtH);
                glTexCoord2d(ru, 1);       glVertex2i(moteur.getLargeurEcran() -  5  ,m_gauche_txtH);
                glTexCoord2d(ru, 1-rv);    glVertex2i(moteur.getLargeurEcran() -  5 ,0);
            glEnd();

    glDisable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);
}
