#include "divers.h"

// Pour la bibliotheques freetype
inline int next_p2 (int a );
ILuint getChar(FT_Face face,unsigned char character);
#define max(x,y) x>y?x:y
#define min(x,y) x<y?x:y
// Cration d'un objet pour le texte (variable global)
FT_Library ft_library;
FT_Face face;

// Pour le cryptage
FILE *fptr1;
FILE *fptr2;


char filename1[50];
char filename2[50];
char clef[30] = "smash2dhybrixsybrix";

/**************************
*         Charger
*      les textures
**************************/
GLuint chargerTexture(const char * filename, bool useMipMap)
{
    ILuint  ilimage;
    GLuint id;

    ilGenImages(1,&ilimage);
    ilBindImage(ilimage);
    ilLoad(IL_TYPE_UNKNOWN ,(ILstring)filename);
    ilConvertImage(IL_RGBA, IL_UNSIGNED_BYTE);
    iluFlipImage();

    glGenTextures(1,&id);
    glBindTexture(GL_TEXTURE_2D,id);

    if (useMipMap)
    {

        gluBuild2DMipmaps(GL_TEXTURE_2D, 4, ilGetInteger(IL_IMAGE_WIDTH),
                          ilGetInteger(IL_IMAGE_HEIGHT), GL_RGBA,GL_UNSIGNED_BYTE,
                          ilGetData());

        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,
                        GL_LINEAR_MIPMAP_LINEAR);

    }
    else
    {
        glTexImage2D(GL_TEXTURE_2D, 0, 4, ilGetInteger(IL_IMAGE_WIDTH),
                     ilGetInteger(IL_IMAGE_HEIGHT), 0, GL_RGBA,GL_UNSIGNED_BYTE,
                     ilGetData());
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    }
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

    ilDeleteImages(1, &ilimage);
    return id;
}

/**************************
*         Charger
*      les textures (Devil)
**************************/
ILuint loadImage(const char * filename)
{
    //code simple pour faire en une ligne, "comme IMG_Load".
    //sauf qu'ici on s'assure qu'on est dans un format propre
    ILuint  ilimage;
    ilGenImages(1,&ilimage);
    ilBindImage(ilimage);
    ilLoad(IL_TYPE_UNKNOWN ,(ILstring)filename);
    ilConvertImage(IL_RGBA, IL_UNSIGNED_BYTE);
    return ilimage;
    //ne pas oublier ( l'utilisateur) de faire un delete sur cet identifiant
}

/**************************
*     Fonction de Kayl
*     (gestion images)
**************************/
ILuint getEmptyImage(unsigned int width,unsigned int height)
{
    ILuint image;
    ilGenImages(1,&image);
	ilBindImage(image);
    ilTexImage(width,height,1,4,IL_RGBA,IL_UNSIGNED_BYTE,NULL);
    ilClearColour(0,0,0,0);
    ilClearImage();
    return image;
}

/**************************
*   Convertir texte
*     en texture
**************************/
void createTextureFromText(GLuint id_texture,const char * text,unsigned int &good_textW ,unsigned int &good_textH ,unsigned int &total_textW,unsigned int &total_textH, int taille)
{
    FT_New_Face( ft_library, "../media/fonts/goodfish.ttf", 0, &face );
	FT_Set_Pixel_Sizes( face,0,taille);
	unsigned int offset_x = 0;
	int ymin = 999;
	int ymax = 0;
	int local_x = 0;
	int local_y = 0;
	ILuint text_image;
	ILuint char_image;
	SDL_Rect dstrect;

	offset_x = 0;
	for (const char * ptr = text; *ptr != '\0'; ptr++)
	{
		FT_Load_Char(face,*ptr,FT_LOAD_RENDER );
		ymin = min(ymin,face->glyph->bitmap_top - face->glyph->bitmap.rows);
		ymax = max(ymax,face->glyph->bitmap_top);
		offset_x += face->glyph->advance.x>>6;
	}

	good_textW = offset_x + 5;
	good_textH = ymax-ymin;
	total_textW = next_p2(good_textW);
	total_textH = next_p2(good_textH);

	text_image = getEmptyImage(total_textW,total_textH);
	dstrect.x = 0;
	dstrect.y = 0;
	offset_x = 0;
	for (const char * ptr = text; *ptr != '\0'; ptr++)
	{
		char_image = getChar(face,*ptr);
		local_x = offset_x + face->glyph->bitmap_left;
		local_y = ymax - face->glyph->bitmap_top;
		dstrect.x = max(local_x,0);
		dstrect.y = local_y;
		BlitImage(char_image,NULL,text_image,&dstrect);
		ilDeleteImages(1, &char_image);
		offset_x += face->glyph->advance.x>>6;
	}

	iluFlipImage();

    glBindTexture(GL_TEXTURE_2D, id_texture);

	ilBindImage(text_image);
    glTexImage2D(GL_TEXTURE_2D, 0, 4, ilGetInteger(IL_IMAGE_WIDTH),
                     ilGetInteger(IL_IMAGE_HEIGHT), 0, GL_RGBA,GL_UNSIGNED_BYTE,
                     ilGetData());
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	ilDeleteImages(1, &text_image);
	ilDeleteImages(1, &char_image);
}


/**************************
*     Fonction de Kayl
*     (gestion texte ?)
**************************/
ILuint getChar(FT_Face face,unsigned char character)
{
	ILuint char_image;

	FT_Load_Char(face,character,FT_LOAD_RENDER );

	unsigned int width = face->glyph->bitmap.width;
	unsigned int height = face->glyph->bitmap.rows;
	char_image = getEmptyImage(width,height);
	ilBindImage(char_image);

	unsigned char * data = ilGetData();

	unsigned char * pDest = &data[0];
	unsigned char * pSrc = face->glyph->bitmap.buffer;
	switch (face->glyph->bitmap.pixel_mode)
	{
	case FT_PIXEL_MODE_MONO:
		{
			int cur_bit = 7;
			for (unsigned int y = 0; y < height; y++)
			{
				for (unsigned int x = 0; x < width; x++)
				{
					if (*pSrc & (1<<cur_bit))
					{
						memset(pDest,0,3);
						pDest[3] = 0;
					}
					else
						memset(pDest,0,4);
					cur_bit--;
					if (cur_bit == -1)
					{
						pSrc++;
						cur_bit = 7;
					}
					pDest += 4;
				}
				if (cur_bit != 7)
				{
					cur_bit = 7;
					pSrc++;
				}
			}
		}
		break;
	case FT_PIXEL_MODE_GRAY:
		for (unsigned int y = 0; y < height; y++)
		{
			for (unsigned int x = 0; x < width; x++)
			{
				if (*pSrc == 0)
					memset(pDest,0,3);
				else
					memset(pDest,0,3);
				pDest[3] = *pSrc;
				pSrc++;
				pDest +=4;
			}
			pSrc += face->glyph->bitmap.pitch-width;
		}
		break;
	}
	return char_image;
}

/**************************
*     Fonction de Kayl
*     (gestion images)
**************************/
inline int next_p2 (int a )
{
	int rval=1;
	// rval<<=1 Is A Prettier Way Of Writing rval*=2;
	while(rval<a) rval<<=1;
	return rval;
}


/**************************
*     Fonction de Kayl
*     (gestion images)
**************************/
void BlitImage(ILuint src,SDL_Rect *srcrect,ILuint dest,SDL_Rect *dstrect)
{
    //TODO : a peut etre amlior avec des "tests" de validit
    //mais on va faire comme SDL_Blit > cad aucun test

    SDL_Rect from;
    SDL_Rect to;

    ilBindImage(src);
    if (srcrect == NULL)
    {
        from.x = 0;
        from.y = 0;
        from.w = ilGetInteger(IL_IMAGE_WIDTH);
        from.h = ilGetInteger(IL_IMAGE_HEIGHT);
    }
    else
        from = *srcrect;

    if (dstrect == NULL)
    {
        to.x = 0;
        to.y = 0;
    }
    else
        to = *dstrect;

    unsigned char * tmp_data = new unsigned char[4*from.w*from.h];
    ilCopyPixels(from.x,from.y,0,from.w,from.h,1,IL_RGBA,IL_UNSIGNED_BYTE,tmp_data);

    ilBindImage(dest);
    ilSetPixels(to.x, to.y,0,from.w,from.h,1,IL_RGBA,IL_UNSIGNED_BYTE,tmp_data);
    delete [] tmp_data;

}

/**************************
*    Initialisation de
*       Freetype
**************************/
void InitFontEngine()
{
	FT_Init_FreeType( &ft_library );
}

/**************************
*
*   Fermeture de Freetype
*
**************************/
void ShutdownFontEngine()
{
	FT_Done_FreeType(ft_library);
}
