/*******************************************************************************
*                               [ utiles.h ]
*   Ce fichier contient les prototypes de utiles.cpp
*   Utiles.cpp contient de nombreuses fonctions utiles :
*
*   - GLuint chargerTexture(...) :
*          Fonction permettant la convertion d'image en ID pour OpenGL.
*
*   - void createTextureFromText(...);
*          Fonction pour crer du texte.
*
*   - inline int next_p2 (int a );
*          Fonction obligatoire pour la fonction ci-dessus.
*
*
*******************************************************************************/
#ifndef DIVERS
    #define DIVERS

#include <iostream>
#include <SDL.h>
#include <SDL_opengl.h>
#include <IL/il.h>
#include <IL/ilu.h>
#include <ft2build.h>
#include FT_FREETYPE_H

#include "define.h"

GLuint chargerTexture(const char * filename, bool useMipMap = false);
ILuint loadImage(const char * filename);
ILuint getEmptyImage(unsigned int width,unsigned int height);
void createTextureFromText(GLuint id_texture,const char * text,unsigned int &good_textW ,unsigned int &good_textH ,unsigned int &total_textW,unsigned int &total_textH, int taille);
void BlitImage(ILuint src,SDL_Rect *srcrect,ILuint dest,SDL_Rect *dstrect);
void InitFontEngine();
void ShutdownFontEngine();

#endif
